Attribute VB_Name = "modDetectSSD"
Option Explicit
                         
Private Type ATA_PASS_THROUGH_EX
  Length As Integer
  AtaFlags As Integer
  PathId As Byte
  TargetId As Byte
  Lun As Byte
  ReservedAsUchar As Byte
  DataTransferLength As Long
  TimeOutValue As Long
  ReservedAsUlong As Long
  DataBufferOffset As Long
  PreviousTaskFile(0 To 7) As Byte
  CurrentTaskFile(0 To 7) As Byte
End Type

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function DeviceIoControl Lib "kernel32.dll" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, ByRef lpInBuffer As Any, ByVal nInBufferSize As Long, ByRef lpOutBuffer As Any, ByVal nOutBufferSize As Long, ByRef lpBytesReturned As Long, ByRef lpOverlapped As Any) As Long

Private Const GENERIC_READ As Long = &H80000000
Private Const GENERIC_WRITE As Long = &H40000000
Private Const FILE_SHARE_READ As Long = &H1
Private Const FILE_SHARE_WRITE As Long = &H2
Private Const FILE_ANY_ACCESS As Long = &H0
Private Const FILE_READ_ACCESS  As Long = &H1
Private Const FILE_WRITE_ACCESS As Long = &H2
Private Const OPEN_EXISTING As Long = 3

Private Const IOCTL_ATA_PASS_THROUGH = &H4D02C
Private Const STORAGE_DEVICE_SEEK_PENALTY_PROPERTY = 7
Private Const PROPERTY_STANDARD_QUERY = 0
Private Const ATA_FLAGS_DATA_IN = &H2
Private Const ATA_IDENTIFY_DEVICE = &HEC

Private Type ATA_PASS_THROUGH_EX_BUFF
  header As ATA_PASS_THROUGH_EX
  Data(512) As Byte
End Type

Sub Main()
    Dim sDrive As String
    sDrive = "D:" 'Set needed drive
    If IsSSDDrive(sDrive, True) = False Then
        MsgBox "Drive " & Chr(34) & sDrive & Chr(34) & " is HDD Disk."
    Else
        MsgBox "Drive " & Chr(34) & sDrive & Chr(34) & " is SSD Disk."
    End If
End Sub

Public Function IsSSDDrive(sDrive As String, Optional bOutputAnswer As Boolean = False) As Boolean
    Dim lHandle As Long, lRetVal_Size As Long, lResult As Long, DiskData As ATA_PASS_THROUGH_EX
    Dim lBytesReturned As Long, inBufferSize As Long, DiskDataBuffer As ATA_PASS_THROUGH_EX_BUFF
    'Create Device Handle
    lHandle = CreateFile("\\.\" & sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0&, 0&)
    
    'Is handle is not created exit function
    If lHandle = 0 Then
        MsgBox "Error with creating disk handle (WinAPI: CreateFile function ): #" & Err.LastDllError
        Exit Function
    End If
    
    'Create ATA_PASS_THROUGH_EX structure
    DiskData.Length = Len(DiskData)
    DiskData.AtaFlags = 2 ' ATA_FLAGS_DATA_IN
    DiskData.DataTransferLength = 512 'The command returns a 512 byte package of info.
    DiskData.TimeOutValue = 3 '10 second timeout.
    DiskData.CurrentTaskFile(6) = 236 'the command "IDENTIFY DEVICE"
    DiskData.DataBufferOffset = Len(DiskData)
        
    inBufferSize = Len(DiskDataBuffer)
    DiskDataBuffer.header = DiskData
    
    'Execute DeviceIoControl Command
    lResult = DeviceIoControl(lHandle, IOCTL_ATA_PASS_THROUGH, DiskDataBuffer, inBufferSize, DiskDataBuffer, inBufferSize, lBytesReturned, ByVal 0&)

    If lResult = 0 Then
        'Error
        MsgBox "Error with executing DeviceIoControl command: #" & Err.LastDllError
        CloseHandle lHandle
    Else
        'Success
        If bOutputAnswer = True Then OutputDeviceAnswer "C:\Users\Public\Desktop\DetectSSD_Log.txt", DiskDataBuffer.Data()
        If (DiskDataBuffer.Data(216) = 2) Then
            IsSSDDrive = True
        Else
            IsSSDDrive = False
        End If
    End If
        
    CloseHandle lHandle
End Function

Private Sub OutputDeviceAnswer(sPath As String, bArray() As Byte)
    Dim iFile As Integer
    iFile = FreeFile
    Open sPath For Binary As #iFile
    Put #iFile, , bArray
    Close #iFile
End Sub
